#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>

#define PLUGIN_VERSION "1.2"

public Plugin:myinfo = 
{
	name = "DoD DropTNT Source",
	author = "BenSib",
	description = "Players drop tnt on death / by command!",
	version = PLUGIN_VERSION,
	url = "http://www.dodsplugins.com"
}

#define MAXENTITIES 1024

new Handle:TnTDropTimer[MAXENTITIES+1] = INVALID_HANDLE;

new String:g_TnT_Model[] = { "models/weapons/w_tnt.mdl" };
new String:g_TnT_Sound[] = { "weapons/c4_pickup.wav" };

new Handle:tntdeaddrop = INVALID_HANDLE;
new Handle:tntdropcmd = INVALID_HANDLE;
new Handle:tntliefetime = INVALID_HANDLE;
new Handle:tntcooldown = INVALID_HANDLE;
new Handle:tntnotify = INVALID_HANDLE;
new bool:tnt_candrop[MAXPLAYERS];

public OnPluginStart()
{	
	CreateConVar("dod_droptnt_version", PLUGIN_VERSION, "DoD DropTnT Source Version (DO NOT CHANGE!)", FCVAR_DONTRECORD|FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	SetConVarString(FindConVar("dod_droptnt_version"), PLUGIN_VERSION);
	
	tntdeaddrop = CreateConVar("dod_droptnt_deaddrop", "1", "<1/0> = enable/disable dropping a tnt on players' death (default: 1)", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	tntdropcmd = CreateConVar("dod_droptnt_alivedrop", "1", "<1/0> = enable/disable allowing alive players to drop their tnt (default: 1)", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	tntnotify = CreateConVar("dod_droptnt_notify", "1", "<1/0> = enable/disable drop/pickup message to player (default: 1)", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	tntliefetime = CreateConVar("dod_droptnt_lifetime", "30", "<#> = number of seconds a dropped tnt stays on the map (default: 30)", FCVAR_PLUGIN, true, 5.0, true, 60.0);
	tntcooldown = CreateConVar("dod_droptnt_cooldown", "10", "<#> = number of seconds between two dropcommands (default: 10)", FCVAR_PLUGIN, true, 5.0, true, 60.0);
	
	RegConsoleCmd("dropammo",cmdDropTnT);
	HookEvent("player_hurt", OnPlayerDeath, EventHookMode_Pre);
	AutoExecConfig(true, "dod_droptnt_source", "dod_droptnt_source");
}

public OnClientPutInServer(client)
{
	tnt_candrop[client] = true;
}

public Action:cmdDropTnT(client, args) 
{
	if(!IsPlayerAlive(client) || !IsClientInGame(client) || GetConVarInt(tntdropcmd) == 0 || !tnt_candrop[client])
	{
		return Plugin_Continue;
	}
	
	new wpn = GetPlayerWeaponSlot(client, 4);
	if(wpn != -1)
	{
		new Float:origin[3];
		GetClientAbsOrigin(client, origin);
		origin[2] += 55.0;
		new Float:angles[3];
		GetClientEyeAngles(client, angles);
		new Float:velocity[3];
		GetAngleVectors(angles, velocity, NULL_VECTOR, NULL_VECTOR);
		NormalizeVector(velocity,velocity);
		ScaleVector(velocity,350.0);
		new tnt = CreateEntityByName("prop_physics_override");
		SetEntityModel(tnt,g_TnT_Model);
		DispatchSpawn(tnt);
		TeleportEntity(tnt, origin, angles, velocity);
		SDKHook(tnt, SDKHook_Touch, OnTnTTouched);
		tnt_candrop[client] = false;
		CreateTimer(GetConVarFloat(tntcooldown), EnableDrop, client);
		TnTDropTimer[tnt] = CreateTimer(GetConVarFloat(tntliefetime), RemoveDroppedTnT, tnt, TIMER_FLAG_NO_MAPCHANGE);
		RemoveWeapon(client, wpn);
		if (GetConVarInt(tntnotify) == 1)
		{
			PrintHintText(client, "You dropped TNT");
		}
		return Plugin_Handled;
	}
	
	return Plugin_Continue;
}

RemoveWeapon(client, wpn) {
	RemovePlayerItem(client, wpn);
	AcceptEntityInput(wpn, "Kill");
	//RemoveEdict(wpn);
}

public Action:RemoveDroppedTnT(Handle:timer, any:tnt)
{
	TnTDropTimer[tnt] = INVALID_HANDLE;
	SDKUnhook(tnt, SDKHook_Touch, OnTnTTouched);
	if(IsValidEdict(tnt))
	{
		decl String:iModel[PLATFORM_MAX_PATH];
		Format(iModel,PLATFORM_MAX_PATH,"");
		GetEntPropString(tnt,  Prop_Data, "m_ModelName", iModel, PLATFORM_MAX_PATH);
		if (StrEqual(iModel, g_TnT_Model))
		{
			AcceptEntityInput(tnt, "Kill");
		}
	}
	return Plugin_Handled;
}

public Action:OnPlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(GetClientHealth(client) > 0 || !IsClientInGame(client) || GetConVarInt(tntdeaddrop) == 0)
	{
		return Plugin_Continue;
	}
	new wpn = GetPlayerWeaponSlot(client, 4);
	if(wpn != -1)
	{
		new Float:deathorigin[3];
		GetClientAbsOrigin(client,deathorigin);
		deathorigin[2] += 5.0;
		new tnt = CreateEntityByName("prop_physics_override");
		SetEntityModel(tnt,g_TnT_Model);
		DispatchSpawn(tnt);
		TeleportEntity(tnt, deathorigin, NULL_VECTOR, NULL_VECTOR);
		SDKHook(tnt, SDKHook_Touch, OnTnTTouched);
		TnTDropTimer[tnt] = CreateTimer(GetConVarFloat(tntliefetime), RemoveDroppedTnT, tnt, TIMER_FLAG_NO_MAPCHANGE);
	}
	return Plugin_Continue;
}

public Action:OnTnTTouched(tnt, client)
{
	if(client > 0 && client <= GetMaxClients() && tnt > 0 && IsValidEntity(client) && IsClientInGame(client) && IsPlayerAlive(client) && IsValidEdict(tnt))
	{		
		new wpn = GetPlayerWeaponSlot(client, 4);
		if(wpn == -1)
		{
			if (GetConVarInt(tntnotify) == 1)
			{
				PrintHintText(client, "You picked up TNT");
			}
			GivePlayerItem(client, "weapon_basebomb");
			KillTnTTimer(tnt);
			PlayPickUpSound(client);
			SDKUnhook(tnt, SDKHook_Touch, OnTnTTouched);
			decl String:iModel[PLATFORM_MAX_PATH];
			Format(iModel,PLATFORM_MAX_PATH,"");
			GetEntPropString(tnt,  Prop_Data, "m_ModelName", iModel, PLATFORM_MAX_PATH);
			if (StrEqual(iModel, g_TnT_Model))
			{
				//RemoveEdict(tnt);
				AcceptEntityInput(tnt, "Kill");
			}
			return Plugin_Handled;
		}
	}
	return Plugin_Handled;
}


public Action:EnableDrop(Handle:timer, any:x)
{
	tnt_candrop[x] = true;
}

stock KillTnTTimer(tnt)
{
	if(TnTDropTimer[tnt] != INVALID_HANDLE)
	{
		CloseHandle(TnTDropTimer[tnt]);
	}
	TnTDropTimer[tnt] = INVALID_HANDLE;
}

stock PlayPickUpSound(client)
{
	EmitSoundToClient(client, g_TnT_Sound, SOUND_FROM_PLAYER,SNDCHAN_WEAPON,SNDLEVEL_NORMAL, SND_NOFLAGS, SNDVOL_NORMAL, SNDPITCH_NORMAL);
}


	